* Program for obtaining Standard error by the diagonal of the 
* inverse of Hessian Matrix, uses NAG (1996) routines 
	  implicit none
        integer ni
*Number of Cows=ni
        parameter (ni=107)
        integer nout,nin,n,lhes
        parameter (nin=5,nout=6,n=16,lhes=n)
*Number of parameters=n
        integer nmax
        parameter (nmax=34)
        integer ia,ib
        parameter (ia=nmax+1,ib=nmax)
        integer     lwork
        parameter   (lwork=n*n+n)
        integer rd(ni),ex(ni,5),i,ifail,mode
     +  ,iuser(1),msglvl,iwarn,info(n),j
        real*8 y(ni,2),objgrd(n)
     +  ,user(1),work(lwork), x(n),epsrf,hforw(n)
     +  ,hcntrl(n),hesian(lhes,n),hes(ia,nmax),se(nmax),z(nmax)
     +  ,b(ib,nmax),objf
        external e04xaf,objfun,f01abf
        common y,rd,ex 
        open(nin,file='selikp.dat',status='old')
        open(nout,file='selikp.out',status='unknown')
*Reading the estimates of the parameters (x) from file selikp.dat  
        read (nin,*) (x(i),i=1,n)
*Reading the mastitis data 
        do 11 i=1,ni
        read (nin,*)rd(i),y(i,1),y(i,2),(ex(i,j),j=1,5)
  11    continue
	  msglvl=0
	  epsrf=-1.0
	  do 2 i=1,n
	  hforw(i)=-1.0
  2     continue  
	  mode=2
	  ifail=1
*calling the routine for evaluting Hessian Matrix (hesian)
	  call e04xaf(msglvl,n,epsrf,x,mode,objfun,lhes,hforw,objf,
     +  objgrd,hcntrl,hesian,iwarn,work,iuser,user,info,ifail)
	  do 21 i=1,n
	  do 21 j=1,n
  21	  hes(i,j)=hesian(i,j)
        ifail=1
*Finding the inverse of hesian (b) and using diagonal of 
*b as standard error (se) 
        call f01abf(hes,ia,n,b,ib,z,ifail)
        do 17 i=1,n
        se(i)=b(i,i)**0.5
*Writing index of parameters, estimates of the parameter and s.e. 
        write(nout,*)i,x(i),se(i)
  17    continue
        stop
        end
*Object function the same as the main program's object function
*This has to be used to obtain the observed information matrix.  
        subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,user)
        implicit none
        character tail
        integer ni
        parameter (ni=107)
        integer mode,n,nstate,ifail
        integer i,iuser(*),rd(ni),ex(ni,5)
        real*8 objgrd(n),user(*),g01eaf,objf
        real*8 y(ni,2)
        real*8 f1,f2,q,q1,q2,q3,q4,q5,q6,q7,q8,q9,sum,x(n)
        external g01eaf
        common y,rd,ex
        data tail/'l'/
        if(mode.eq.0 .or. mode.eq.2)then
        objf=0.0
        do 120 i=1,ni
        sum=0
        if(rd(i) .eq. 1)then
        q1=x(1)+x(2)*ex(i,1)+x(3)*ex(i,2)+x(4)*ex(i,3)+x(5)*ex(i,4)
        f1=dexp((-1.0/(2*x(6)**2))*(y(i,1)-q1)**2)/(2.506628*x(6))
        q2=x(1)+x(2)*ex(i,1)+x(3)*ex(i,2)+x(4)*ex(i,3)+x(5)*ex(i,4)+
     +  x(7)+(x(9)*x(8)/x(6))*(y(i,1)-q1)
*
        q3=sqrt(x(8)**2-(x(9)**2*x(8)**2))
*
        f2=dexp((-1/(2*q3**2))*(y(i,2)-q2)**2)/(2.506628*q3)
*
        q4=(x(6)*x(8))**2*(1-x(9)**2)
*
        q5=x(6)*x(10)*x(8)**2-x(6)*x(8)**2*x(9)*x(11)
*
        q6=x(6)**2*x(8)*x(11)-x(6)**2*x(8)*x(10)*x(9)
*
        q7=x(12)+x(13)*ex(i,4)+x(14)*ex(i,1)+x(15)*ex(i,2)+x(16)*ex(i,3)
     +  +q5
     +  *(y(i,1)-q1)/q4
     +  +q6*(y(i,2)-x(1)-x(2)*ex(i,1)-x(3)*ex(i,2)-x(4)*ex(i,3)-
     +  x(5)*ex(i,4)-x(7))/q4
*
        q8=(x(10)**2-2*x(9)*x(10)*x(11)+x(11)**2)/(1-x(9)**2)
*
        if( q8 .gt. 1 ) then
        q8=0
        q7=-3
        end if
        q8=(1.0-q8)**0.5
        q9=q7/q8
        ifail=0
        q=g01eaf(tail,q9,ifail)
        sum=f1*f2*q
*
        else 
        q1=x(1)+x(2)*ex(i,1)+x(3)*ex(i,2)+x(4)*ex(i,3)+x(5)*ex(i,4)
*
        f1=dexp((-1/(2*x(6)**2))*(y(i,1)-q1)**2)/(2.506628*x(6))
        q2=x(12)+x(13)*ex(i,4)+x(14)*ex(i,1)+x(15)*ex(i,2)+x(16)*ex(i,3)
     +  +x(10)*(y(i,1)-q1)/x(6)
        q3=sqrt(1.0-x(10)**2)  
 
        q6=-q2/q3
*
        ifail=0
        q=g01eaf(tail,q6,ifail)
        sum=f1*q
        endif
        if(sum.eq.0.0)sum=1.0d-300
        objf=(-1)*dlog(sum)+objf
 120    continue 
*       write(6,*)x
        endif  
        return
        end

